<template>
  <transition name="slide">
    <div v-if="alerts.length > 0">
      <div
        v-for="(alert, i) in alerts"
        :key="i"
        class="alert text-white px-6 py-4 border-0 rounded relative mb-4"
      >
        <lull-icon
          icon="fa-times absolute right-5 cursor-pointer opacity-60 hover:opacity-100"
          @click="close(alert.id)"
        />
        <lull-icon
          icon="fa-bell"
          class="text-xl inline-block mr-5 align-middle"
        />
        <span class="inline-block align-middle mr-8" v-html="alert.message" />
      </div>
    </div>
  </transition>
</template>

<script lang="ts">
import { useStore } from '@/store';
import { AlertMutation } from '@/store/Alert/AlertModule';
import { computed, defineComponent } from 'vue';

export default defineComponent({
  name: 'alert',
  setup() {
    const store = useStore();
    const alerts = computed(() => store.getters.alerts);

    function close(id: string): void {
      store.commit(AlertMutation.RemoveAlert, id);
    }

    return { alerts, close };
  },
});
</script>

<style lang="scss" scoped>
@import '../assets/css/variables.scss';

.alert {
  background-color: $button-secondary;
}

.slide-enter-active {
   -moz-transition-duration: 0.3s;
   -webkit-transition-duration: 0.3s;
   -o-transition-duration: 0.3s;
   transition-duration: 0.3s;
   -moz-transition-timing-function: ease-in;
   -webkit-transition-timing-function: ease-in;
   -o-transition-timing-function: ease-in;
   transition-timing-function: ease-in;
}

.slide-leave-active {
   -moz-transition-duration: 0.3s;
   -webkit-transition-duration: 0.3s;
   -o-transition-duration: 0.3s;
   transition-duration: 0.3s;
   -moz-transition-timing-function: cubic-bezier(0, 1, 0.5, 1);
   -webkit-transition-timing-function: cubic-bezier(0, 1, 0.5, 1);
   -o-transition-timing-function: cubic-bezier(0, 1, 0.5, 1);
   transition-timing-function: cubic-bezier(0, 1, 0.5, 1);
}

.slide-enter-to, .slide-leave {
   max-height: 100px;
   overflow: hidden;
}

.slide-enter, .slide-leave-to {
   overflow: hidden;
   max-height: 0;
}
</style>